#include<stdlib.h>

#include"DspLib.h"
#include"DspDriver.h"
#include"DebugLib.h"

#ifdef ESD_SOUND
#include<esd.h>
#endif

t_dsp* open_dsp_for_play(name,bits_per_sample,channels,rate,esd_client)
     char* name;
     int   bits_per_sample;
     int   channels;
     int   rate;
     char* esd_client;
{
  BOOL  duplex = FALSE_;
  int    tempfile;
  t_dsp* tempdsp;

  if (strcmp(esd_client,"") != 0)
    {
#ifdef ESD_SOUND
      tempfile = esd_play_stream(ESD_BITS16 | ESD_STEREO | ESD_STREAM | ESD_PLAY, 44100, esd_client, ESD_GMURF_ID);
#endif
    }
  else
    {
      tempfile = 
	dsp_init_for_rec_and_play(name, bits_per_sample, channels, rate);
      if (tempfile == -1)
	{
	  tempfile = dsp_init_for_play(name, bits_per_sample, channels, rate);
	  duplex = FALSE_;
	}
      else
	{
	  duplex = TRUE_;
	}
    }
  if (tempfile < 0)
    return (NULL);

  tempdsp = (t_dsp*) malloc(sizeof(t_dsp));

  tempdsp->duplex = duplex;
  tempdsp->lock = FALSE_;
  tempdsp->rec_or_play = PLAY;
  tempdsp->bits_per_sample = bits_per_sample;
  tempdsp->channels = channels;
  tempdsp->sample_rate = rate;
  tempdsp->name = name;
  tempdsp->file = tempfile;
  //  strcpy(tempdsp->esd_client, esd_client);

  return (tempdsp);

} /* open_dsp_for_play */

t_dsp* open_dsp_for_record(name,bits_per_sample,channels,rate, esd_client)
     char* name;
     int   bits_per_sample;
     int   channels;
     int   rate;
     char  *esd_client;
{
  BOOL   duplex;
  int    tempfile;
  t_dsp* tempdsp;
  
  if (strcmp(esd_client,"") != 0)
    {
#ifdef ESD_SOUND
      tempfile = esd_record_stream(ESD_BITS16 | ESD_STEREO | ESD_STREAM | ESD_RECORD, 44100, "gmurf", ESD_GMURF_ID);
#endif
    }
  else
      tempfile = 
	dsp_init_for_rec_and_play(name, bits_per_sample, channels, rate);
      if (tempfile == -1)
	{
	  tempfile = dsp_init_for_record(name, bits_per_sample, channels, rate);
	  duplex = FALSE_;
	}
      else
	{
	  duplex = TRUE_;
	}

  if (tempfile < 0)
    return (NULL);

  tempdsp = (t_dsp*) malloc(sizeof(t_dsp));

  tempdsp->lock = FALSE_;
  tempdsp->rec_or_play = REC;
  tempdsp->bits_per_sample = bits_per_sample;
  tempdsp->channels = channels;
  tempdsp->sample_rate = rate;
  tempdsp->name = name;
  tempdsp->file = tempfile;

  return (tempdsp);

} /* open_dsp_for_record */

int close_dsp(dsp)
     t_dsp* dsp;
{
  if (dsp == NULL)
    {
      warning("DspLib.c: close_dsp: I can't destroy"
	      " a NULL t_dsp*");
      return(-1);
    }

  if (dsp_close(dsp->file) != 0)
    {    
      warning("DspLib.c: close_dsp: Can't close file");
      return (-2);
    }

  free(dsp);
  return (0);
} /* close_dsp */

BOOL dsp_lock(dsp)
     t_dsp* dsp;
{
  if (dsp->lock == TRUE_)
    return (FALSE_); /* DSP dj utilis */

  dsp->lock = TRUE_ ;

  return (TRUE_);

} /* dsp_lock retourne TRUE_ si c'est bon ou FALSE_ si le DSP est dj utilis */

BOOL dsp_unlock(dsp)
     t_dsp* dsp;
{
  dsp->lock = FALSE_;
  return (TRUE_);
} /* dsp_unlock */

BOOL is_dsp_locked(dsp)
     t_dsp* dsp;
{
  return (dsp->lock);
} /* is_dsp_locked */
