/*
 * DspLib.h
 *
 * _psl_
 *
 * Last update 02 17 99
 *
 */



#ifndef DSPLIB_H
#define DSPLIB_H

#include"Constants.h"

typedef struct s_dsp t_dsp;
struct s_dsp
{
  BOOL      duplex;
  BOOL      lock;
  BOOL      rec_or_play;
  BOOL      processed; // modified 02 17 99
  int       file; /* file descriptor */
  char*     name;
  int       bits_per_sample;
  int       channels;
  int       sample_rate;
  int       big_buf[BUFFER_SIZE]; // modified 17 02 99
  short int buffer[BUFFER_SIZE];
  char*     esd_client;
};

t_dsp* open_dsp_for_play(		/* ouvre le dsp en mode lecture */
			 char*,			/* nom du dsp */
			 int,			/* bits par sample */
			 int,			/* nb voix */
			 int,			/* frquence */
			 char*                  /* Nom du serveur esd si on est client */
 );

t_dsp* open_dsp_for_record(		/* ouvre le dsp en mode enregistrement */
			   char*,		/* nom du dsp */
			   int,			/* bps */
			   int,			/* voix */
			   int,			/* freq */
			   char*                /* Nom du serveur esd si on est client */
);

int    close_dsp(			/* ferme le dsp */
		 t_dsp*				/* dsp a fermer */
);

BOOL   dsp_unlock(			/* de-lock le dsp */
		  t_dsp*			/* dsp  dlocker */
);

BOOL   dsp_lock(			/* lock le dsp */
		t_dsp*				/* dsp  locker */
);

BOOL   is_dsp_locked(			/* dit si le dsp est lock */
		     t_dsp*			/* le dsp est il lock? */
);

#endif

