/*
** mix_sample.c for Gmurf in Gmurf/gui
** 
** Made by Rmi Coupet
** Login   <inthy@sietch.inthy.fr>
** 
** Started on  Wed Mar 10 22:28:36 1999 Rmi Coupet
** Last update Thu Mar 18 13:39:49 1999 Rmi Coupet
*/

#include "mix_sample.h"
#include "Mixer.h"
#include "mixer_list.h"
#include "xpms/mute.xpm"
#include "xpms/mute_light.xpm"
#include "xpms/quit.xpm"	
#include "xpms/quit_light.xpm"
#include "xpms/WE_button.xpm"
#include "xpms/WE_button_light.xpm"
#include "xpms/balance.xpm"
#include "xpms/volume.xpm"
#include "xpms/freq_curve.xpm"
#include "xpms/freq_curve_light.xpm"


static void	mix_sample_class_init		(Mixer_SampleClass	*klass) ;
static void	mix_sample_init			(Mixer_Sample		*ms) ;
static gint	expose_ms 			(GtkWidget		*widget,
						 GdkEventExpose		*event,
						 gpointer		data);
static gint	configure_ms 			(GtkWidget		*widget,
						 GdkEventConfigure	*event,
						 gpointer		data);
void		toggle_rec			(GtkWidget	*widget) ;
void		toggle_mute			(GtkWidget	*widget) ;
void		toggle_freq			(GtkWidget	*widget) ;
void		change_volume			(GtkWidget	*widget) ;
void		change_balance			(GtkWidget	*widget) ;
void		change_dsp_combo		(GtkWidget	*widget) ;
//static gint mix_sample_signals[LAST_SIGNAL] = { 0 };

guint mix_sample_get_type (void)
{
  static guint ms_type = 0;

  if (!ms_type)
  {
    GtkTypeInfo ms_info =
    {
      "Mixer_Sample",
      sizeof (Mixer_Sample),
      sizeof (Mixer_SampleClass),
      (GtkClassInitFunc) mix_sample_class_init,
      (GtkObjectInitFunc) mix_sample_init,
      (GtkArgSetFunc) NULL,
      (GtkArgGetFunc) NULL
    };

    ms_type = gtk_type_unique (gtk_vbox_get_type (), &ms_info);
  }
  
  return ms_type;
}

static void mix_sample_class_init (class)
Mixer_SampleClass *class ;
{
  GtkObjectClass *object_class;
  
  object_class = (GtkObjectClass*) class;  
  class->mix_sample = NULL;
}

GtkWidget *mix_sample_new(void)
{
  return GTK_WIDGET ( gtk_type_new (mix_sample_get_type ()));
}

/* 
** The function which create the base of the wavwin object.
*/

static void	mix_sample_init (ms)
Mixer_Sample	*ms ;
{
  GtkWidget	*hbox ;
  GtkWidget	*vbox ;
  GtkWidget	*label ;
  GSList 	*group ;
  GList		*glist ;
  t_dsprc       *dsprc ;
  GtkAdjustment	*adj ;
  GtkTooltips	*btips ;
  GdkColor		*color1 ;
  GdkColor		*color2 ;
  GdkColormap* 		CMap ;


  color1 = (GdkColor *) malloc(sizeof(GdkColor)) ;
  CMap = gdk_window_get_colormap(MainWindow->window) ;
  SetColor(color1, 0, 0, 0) ;
  gdk_color_alloc(CMap, color1) ;
  color2 = (GdkColor *) malloc(sizeof(GdkColor)) ;
  SetColor(color2, 0, 255, 255) ;
  gdk_color_alloc(CMap, color2) ;

  glist = NULL ;
  ms->frame = gtk_frame_new("");
  gtk_frame_set_shadow_type(GTK_FRAME (ms->frame), GTK_SHADOW_IN);
  gtk_widget_show(ms->frame);
  vbox = gtk_vbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER (ms->frame), vbox);
  hbox = gtk_hbox_new(FALSE, 1);
  
  /* label */
  label = gtk_label_new("Start:");
  gtk_box_pack_start(GTK_BOX (hbox), label, TRUE, TRUE, 0);
  gtk_widget_show(label);
  /* entry */
  ms->entry_date = gtk_entry_new() ;
  gtk_entry_set_text(GTK_ENTRY (ms->entry_date), "0");
  ms->begin = 0 ;
  btips=gtk_tooltips_new();
  gtk_tooltips_set_colors(btips, color1, color2) ;
  gtk_tooltips_set_tip(btips, ms->entry_date, "Begin date", "Begin Date");
  gtk_box_pack_start(GTK_BOX (hbox), ms->entry_date, TRUE, FALSE, 0);
  gtk_widget_show(ms->entry_date);
  /* radio buttuns */
  ms->play_toggle = gtk_radio_button_new_with_label(NULL, "Play");
  gtk_widget_show(ms->play_toggle);
  group = gtk_radio_button_group (GTK_RADIO_BUTTON (ms->play_toggle));
  gtk_signal_connect_object(GTK_OBJECT(ms->play_toggle), "toggled", 
			    GTK_SIGNAL_FUNC(toggle_rec),GTK_OBJECT (ms)) ;
  ms->rec_toggle = gtk_radio_button_new_with_label(group, "Rec");
  gtk_widget_show(ms->rec_toggle);
  gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (ms->play_toggle), TRUE);
  gtk_box_pack_start(GTK_BOX (hbox), ms->play_toggle, TRUE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX (hbox), ms->rec_toggle, TRUE, FALSE, 0);
/* combo box */
  
  
  dsprc = MIXER(Global_Mixer)->gmurfrc->first_dsp;
  while (dsprc != NULL)
  {
    if (dsprc->dsp != NULL)
      glist = g_list_append(glist, dsprc->vendor);
    dsprc = dsprc->next_dsp;
  }
  
  ms->combo = gtk_combo_new();
  btips=gtk_tooltips_new();
  gtk_tooltips_set_colors(btips, color1, color2) ;
  gtk_tooltips_set_tip(btips, GTK_COMBO(ms->combo)->entry, "Chose your card", "Chose your card");
  gtk_combo_set_popdown_strings( GTK_COMBO(ms->combo), glist) ;
  gtk_entry_set_position(GTK_ENTRY(GTK_COMBO(ms->combo)->entry), 0);
//  gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(ms->combo)->entry), "AWE 32");
  gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(ms->combo)->entry), FALSE);

  gtk_signal_connect_object(GTK_OBJECT(GTK_COMBO(ms->combo)->entry), "changed",
			    GTK_SIGNAL_FUNC (change_dsp_combo), GTK_OBJECT (ms)) ;

  gtk_widget_show(ms->combo) ;
  gtk_box_pack_start(GTK_BOX (hbox), ms->combo, TRUE, FALSE, 0);
  /* buttons */
  ms->mute_button = Create_Toggle_Button_with_pixmap_label("",
							   mute_xpm,
							   mute_light_xpm,
							   MainWindow);
  btips=gtk_tooltips_new();
  gtk_tooltips_set_colors(btips, color1, color2) ;
  gtk_tooltips_set_tip(btips, ms->mute_button, "-< mute", "-< mute");
  gtk_signal_connect_object(GTK_OBJECT(ms->mute_button), "toggled", 
			    GTK_SIGNAL_FUNC(toggle_mute),GTK_OBJECT (ms)) ;
  ms->close_button = Create_Button_with_pixmap_label("",
						     quit_xpm,
						     quit_light_xpm,
						     MainWindow);
  gtk_box_pack_start(GTK_BOX (hbox), ms->mute_button, TRUE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX (hbox), ms->close_button, TRUE, FALSE, 0);
  btips=gtk_tooltips_new();
  gtk_tooltips_set_colors(btips, color1, color2) ;
  gtk_tooltips_set_tip(btips, ms->close_button, "/!\\ Close", "/!\\ Close");
  gtk_signal_connect_object(GTK_OBJECT (ms->close_button), "clicked",
			    GTK_SIGNAL_FUNC (close_ms), GTK_OBJECT(ms));
  gtk_widget_show(ms->close_button);
  gtk_widget_show(ms->mute_button);

  gtk_box_pack_start(GTK_BOX (vbox), hbox, TRUE, FALSE, 0);
  gtk_widget_show(hbox);
  /* New HBox */
  hbox = gtk_hbox_new(FALSE, 1);
  /* Volume HScale */
  gtk_box_pack_start(GTK_BOX (hbox),
		     new_pix_from_data(MainWindow, volume_xpm), FALSE, FALSE, 3);
  adj = (GtkAdjustment *) gtk_adjustment_new( 10, 0, 30, 1, 2, 1);
  ms->volume_hscale = gtk_hscale_new(adj) ;
  gtk_widget_set_usize(ms->volume_hscale, 80, 30) ;
  btips=gtk_tooltips_new();
  gtk_tooltips_set_colors(btips, color1, color2) ;
  gtk_tooltips_set_tip(btips, ms->volume_hscale, "Volume", "Volume");
  gtk_widget_show(ms->volume_hscale) ;
  gtk_signal_connect_object(GTK_OBJECT (GTK_RANGE (ms->volume_hscale)->adjustment),
			    "value_changed",
			    change_volume, GTK_OBJECT (ms)) ;
  gtk_box_pack_start(GTK_BOX (hbox), ms->volume_hscale, FALSE, FALSE, 0);
  /* Balance HScale */
  gtk_box_pack_start(GTK_BOX (hbox), 
		     new_pix_from_data(MainWindow, balance_xpm), FALSE, FALSE, 3);
  adj = (GtkAdjustment *) gtk_adjustment_new(0, -10, 10, 1, 2, 1);
  ms->balance_hscale = gtk_hscale_new(adj) ;
  btips=gtk_tooltips_new();
  gtk_tooltips_set_colors(btips, color1, color2) ;
  gtk_tooltips_set_tip(btips, ms->balance_hscale, "Balance", "Balance");
  gtk_widget_set_usize(ms->balance_hscale, 80, 30) ;
  gtk_widget_show(ms->balance_hscale) ;
  gtk_signal_connect_object(GTK_OBJECT (GTK_RANGE (ms->balance_hscale)->adjustment),
			    "value_changed",
			    change_balance, GTK_OBJECT (ms)) ;
  gtk_box_pack_start(GTK_BOX (hbox), ms->balance_hscale, FALSE, FALSE, 1);
  /* Frequency Curve */
  ms->freq_button = Create_Toggle_Button_with_pixmap_label("",
							   freq_curve_xpm,
							   freq_curve_light_xpm,
							   MainWindow);
  //  gtk_signal_connect_object(GTK_OBJECT(ms->freq_button), "toggled", 
  //			    GTK_SIGNAL_FUNC(toggle_freq),GTK_OBJECT (ms)) ;
  btips=gtk_tooltips_new();
  gtk_tooltips_set_colors(btips, color1, color2) ;
  gtk_tooltips_set_tip(btips, ms->freq_button, "Draw Frequency Curve", 
		       "Draw Frequency Curve");
  gtk_widget_show(ms->freq_button) ;
  gtk_box_pack_start(GTK_BOX (hbox), ms->freq_button, FALSE, FALSE, 2);
 /* Export to the Wav Editor */
  ms->WE_button = Create_Button_with_pixmap_label("-> WE", WE_button_xpm, 
						  WE_button_light_xpm, MainWindow);
  btips=gtk_tooltips_new();
  gtk_tooltips_set_colors(btips, color1, color2) ;
  gtk_tooltips_set_tip(btips, ms->WE_button, "Export to Wav Editor", 
		       "Export to Wav Editor");
  gtk_widget_show(ms->WE_button) ;
  gtk_box_pack_start(GTK_BOX (hbox), ms->WE_button, FALSE, FALSE, 2);

  gtk_box_pack_start(GTK_BOX (vbox), hbox, TRUE, FALSE, 0);

  /* The DrawingArea */
  ms->pixmap = NULL ;
  ms->DrawingArea = gtk_drawing_area_new();
  gtk_drawing_area_size(GTK_DRAWING_AREA (ms->DrawingArea), 
			MIX_SAMPLE_WIDTH,
			MIX_SAMPLE_HEIGHT);
  gtk_widget_show(ms->DrawingArea);
  gtk_signal_connect_object(GTK_OBJECT(ms->DrawingArea),"configure_event",
			    (GtkSignalFunc) configure_ms, 
			    GTK_OBJECT (ms));
  gtk_signal_connect_object(GTK_OBJECT(ms->DrawingArea),"expose_event",
			    (GtkSignalFunc) expose_ms, 
			    GTK_OBJECT (ms));
/*  gtk_signal_connect_object(GTK_OBJECT(ms->DrawingArea),"button_press_event",
			    (GtkSignalFunc) button_ms, ms);
  gtk_signal_connect_object(GTK_OBJECT(ms->DrawingArea),"motion_notify_event",
  (GtkSignalFunc) motion_ms, ms);*/

  gtk_widget_set_events(ms->DrawingArea, GDK_EXPOSURE_MASK
			| GDK_LEAVE_NOTIFY_MASK
			| GDK_BUTTON_PRESS_MASK
			| GDK_POINTER_MOTION_MASK
			| GDK_POINTER_MOTION_HINT_MASK);
  

  gtk_box_pack_start(GTK_BOX(vbox), ms->DrawingArea, TRUE, FALSE, 1);
  gtk_widget_show(vbox);
  gtk_widget_show(hbox);
  gtk_box_pack_start(GTK_BOX (ms), ms->frame, TRUE, TRUE, 0);
}


static gint	expose_ms (widget, 
			   event,
			   data)
GtkWidget	*widget ;
GdkEventExpose	*event ;
gpointer	data ;
{
  Mixer_Sample	*ms ;

  ms = MIX_SAMPLE (widget) ;
  gdk_draw_pixmap(ms->DrawingArea->window,
		  ms->DrawingArea->style->black_gc,
		  ms->pixmap,
		  event->area.x, event->area.y,
		  event->area.x, event->area.y,
		  event->area.width, 
		  event->area.height);
  return FALSE;
}


static gint		configure_ms (widget,
				      event,
				      data)
GtkWidget		*widget;
GdkEventConfigure	*event ;
gpointer		data ;
{
  Mixer_Sample	*ms ;
  
  ms = MIX_SAMPLE (widget) ;
  if (ms->pixmap != NULL)
    gdk_pixmap_unref(ms->pixmap);
  ms->pixmap = gdk_pixmap_new(ms->DrawingArea->window,
			      ms->DrawingArea->allocation.width,
			      ms->DrawingArea->allocation.height,
			      -1);
  ms_draw_wav(ms) ;
  return TRUE;
}


void 		ms_draw_wav(ms)
Mixer_Sample 	*ms ;
{
  GdkRectangle	rec ;
  int 		iwidth ; /* width of the drawing area */
  int		iheight ; /* height of the drawing area */
  gint32	buffer[BUF_SIZE] ; 
  int		file ; /* file descriptor */
  size_t	rd ; /* number of bytes read during the last buffer read */
  size_t	i ; /* just a counter */
  size_t	new_i ;
  int		mid ;
  size_t	nb ;  /* number of gint16 read since start */
  size_t	nb_av ; /* number of gint16 read just before the last buffer read */  
  float		coefx ; 
  float		coefy ;  
  size_t	begin ;
  size_t	end ;
  int		end_i ;
  int		begin_i ;
  int		new_width ;
  GdkColor		*color ;
  GdkColormap* 		CMap ;
  GdkGC			*gc ;

  color = (GdkColor *) malloc(sizeof(GdkColor)) ;
  CMap = gdk_window_get_colormap(
    ms->DrawingArea->window) ;
  gc = gdk_gc_new(MainWindow->window) ;
  SetColor(color, WAV_RED, WAV_GREEN, WAV_BLUE) ;
  gdk_color_alloc(CMap, color) ;
  gdk_gc_set_foreground(gc, color) ;
  gdk_gc_set_background(gc, color) ;

  iwidth = ms->DrawingArea->allocation.width ;
  iheight = ms->DrawingArea->allocation.height ;
  mid = iheight /2 -1 ;
  /* draw a black retangle in both channels */
  gdk_draw_rectangle (ms->pixmap,
		      ms->DrawingArea->style->black_gc,
		      TRUE,
		      0, 0,
		      iwidth, iheight);
  if (ms->tempgmurf->temp_size != 0)
  {
    begin = ms->begin ;
    end = ms->tempgmurf->temp_size / 4 + begin ;
    end_i = (end / (float) (MIXER(Global_Mixer)->max_size)) * iwidth ;
    begin_i = (begin / (float) (MIXER(Global_Mixer)->max_size)) * iwidth ;
    new_width = end_i - begin_i ;
    file = ms->tempgmurf->file ;
    coefx = (ms->tempgmurf->temp_size / 4) / (float) new_width ;
    coefy = mid / (float) MAX_32BITS ;
    nb_av = nb = 0 ;
    lseek(file, 0, SEEK_SET) ;
    nb +=  (rd = read(file, buffer, BUF_SIZE*4))/4 ;
    /* Reading File Loop */
    for (i = 0; i < new_width; i ++)
    {
      new_i = i * coefx ;
      if (new_i > nb)
      {
	while ((rd != 0) && (new_i > nb))
	{
	  nb_av = nb ;
	  nb += (rd = read(file, buffer, BUF_SIZE*4)) / 4 ;
	}
      }
      /* Draw the line */
      gdk_draw_line(ms->pixmap,
		    gc,
		    i + begin_i, mid + buffer[new_i - nb_av] * coefy ,
		    i + begin_i, mid - buffer[new_i - nb_av] * coefy ) ;
    }
  }
  /* Draw the white line, meanong that there is nothing */

  gdk_draw_line(ms->pixmap,
		gc,
		0, mid, iwidth, mid) ;
  gdk_draw_line(ms->pixmap,
		gc,
		0, mid +1, iwidth, mid+1) ;

  /* Redraw of the dranwing areas */
  rec.x = 0;
  rec.y = 0;
  rec.width = iwidth ;
  rec.height = iheight ;

  gtk_widget_draw(ms->DrawingArea, &rec);
}


void		close_ms(widget)
GtkWidget	*widget ;
{
  t_ms_list	*tmp ;
  Mixer_Sample	*ms ;
  size_t	bigger ;
  int		i ;
  
  ms = MIX_SAMPLE (widget) ;

  remove_mixer_elt(MIXER (Global_Mixer)->Main_Mixer, ms->elt) ;
  if (ms->tempgmurf->connected == IN_BOTH)
    ms->tempgmurf->connected = IN_WE ;

  if (ms == MIXER (Global_Mixer)->ms_list->ms)
  {
    tmp = MIXER (Global_Mixer)->ms_list ;
    MIXER (Global_Mixer)->ms_list = MIXER (Global_Mixer)->ms_list->next ;
    free(tmp) ;
  }  
  else
  {
    t_ms_list	*aux ;
    
    tmp = MIXER (Global_Mixer)->ms_list ;
    while(tmp->next->ms != ms)
      tmp = tmp->next ;
    aux = tmp->next ;
    tmp->next = tmp->next->next ;
    free(aux) ;
  }
  MIXER(Global_Mixer)->nb_ms -= 1 ;
  /* Calculate the New Max_Size */
  bigger = 0 ;
  tmp = MIXER(Global_Mixer)->ms_list ;
  for (i = 0 ; i < MIXER(Global_Mixer)->nb_ms ; i++)
  {
    if (bigger < tmp->ms->begin + tmp->ms->tempgmurf->temp_size / 4)
      bigger = tmp->ms->begin + tmp->ms->tempgmurf->temp_size / 4 ;
    tmp = tmp->next ;
  }
  MIXER (Global_Mixer)->max_size = bigger ;

  gtk_widget_destroy(widget) ;
}


void		toggle_rec(widget)
GtkWidget	*widget ;
{
  Mixer_Sample	*ms ;

  ms = MIX_SAMPLE (widget) ;
  if (GTK_TOGGLE_BUTTON (ms->play_toggle)->active)
    ms->elt->rec_or_play = PLAY ;
  else
    ms->elt->rec_or_play = REC ;
}


void		toggle_mute(widget)
GtkWidget	*widget ;
{
  Mixer_Sample	*ms ;

  ms = MIX_SAMPLE (widget) ;
  if (GTK_TOGGLE_BUTTON (ms->mute_button)->active)
    ms->elt->mute = TRUE_ ;
  else 
    ms->elt->mute = FALSE_ ;
}

void		toggle_freq(widget)
GtkWidget	*widget ;
{
  Mixer_Sample	*ms ;

  ms = MIX_SAMPLE (widget) ;
    if (GTK_TOGGLE_BUTTON (ms->mute_button)->active)
    ms->elt->mixer_info->do_freq = TRUE_ ;
  else 
    ms->elt->mixer_info->do_freq = FALSE_ ;
}


void		change_volume(widget)
GtkWidget	*widget ;
{
  Mixer_Sample	*ms ;

  ms = MIX_SAMPLE (widget) ;
  ms->elt->mixer_info->volume = 
    (GTK_RANGE (ms->volume_hscale)->adjustment->value) / 10.0 ;
}


void		change_balance(widget)
GtkWidget	*widget ;
{
  Mixer_Sample	*ms ;

  ms = MIX_SAMPLE (widget) ;
  ms->elt->mixer_info->panning = 
  ( (GTK_RANGE (ms->balance_hscale)->adjustment->value) + 10.0 ) / 20.0 ;
}

void		change_dsp_combo		(widget) 
GtkWidget	*widget;
{
  //t_gmurfrc* 	gmurfrc;
  Mixer_Sample	*ms ;
  char		*str ;
  t_dsprc*	dsprc;
  
  ms = MIX_SAMPLE (widget) ;
  str = gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(ms->combo)->entry)) ;
//  gmurfrc = MIXER(Global_Mixer)->gmurfrc;
  printf("hello world\n");
  
  dsprc = MIXER(Global_Mixer)->gmurfrc->first_dsp;
  while ((dsprc != NULL) && (strcmp(dsprc->vendor,str) != 0))
  {
    dsprc = dsprc->next_dsp;
  }
  
  if (dsprc == NULL)
    puts("Erreur! mix_sample.c: change_dsp_combo: Le vendeur dsp n'a pas t trouv dans la liste.");
  else
    ms->elt->dsp = dsprc->dsp;
}
